#include "stm32l1xx.h"
#include "wait_t6.h"
#include "pins.h"
#include "m25p64.h"

int main(void)
{	
	uint8_t id[3];
	uint8_t sign;
	uint8_t flash_data[10];
	uint8_t wr_flash_data[10] = {0, 1, 2, 3, 4,
															 5, 6, 7, 8, 9};
	volatile uint8_t st;
	
	led_init();
	timer_6_init();
	
	init_m25p();
														
	sign = read_sign();
	if(sign == 0x16)
		read_ID(id);
	
	st = read_sr();
	
	erase_sector(0);
	read_flash(300, 10, flash_data);
	write_flash(300, 10, wr_flash_data);
	read_flash(300, 10, flash_data);
	
	while(1)
	{
		wait_ms(2000);
		led_on();
		wait_ms(2000);
		led_off();
	}
}

