#include "wait_t6.h"

uint8_t volatile f_timer_6_end;

void timer_6_init(void)
{
	TIM_TimeBaseInitTypeDef TIMER_InitStructure;
	NVIC_InitTypeDef  NVIC_InitStructure;

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM6, ENABLE);
	TIM_TimeBaseStructInit(&TIMER_InitStructure);

	TIMER_InitStructure.TIM_CounterMode = TIM_CounterMode_Up;
	TIMER_InitStructure.TIM_Period = 32;
	TIMER_InitStructure.TIM_Prescaler = 1;
	TIM_TimeBaseInit(TIM6, &TIMER_InitStructure);
	
	NVIC_InitStructure.NVIC_IRQChannel = TIM6_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);

	TIM_SelectOnePulseMode(TIM6, TIM_OPMode_Single);	
}

void wait_us(uint32_t n_usec)
{   
	f_timer_6_end = 0;
	
	TIM6->PSC = 0;
	TIM6->ARR = (uint16_t)(32 * n_usec);
	TIM_Cmd(TIM6, ENABLE);
	
	TIM6->EGR |= TIM_EGR_UG;
	TIM6->SR &= ~TIM_SR_UIF;
	
	TIM_ITConfig(TIM6, TIM_IT_Update, ENABLE);
	TIM_Cmd(TIM6, ENABLE);
	
	while(f_timer_6_end == 0);
}

void wait_ms(uint32_t n_msec)
{   
	f_timer_6_end = 0;
	
	TIM6->PSC = 1000 - 1;
	TIM6->ARR = (uint16_t)(32 * n_msec);
	
	TIM6->EGR |= TIM_EGR_UG;
	TIM6->SR &= ~TIM_SR_UIF;
	
	TIM_ITConfig(TIM6, TIM_IT_Update, ENABLE);
	TIM_Cmd(TIM6, ENABLE);
	
	while(f_timer_6_end == 0);
}
